#include<ncl_dcmatrix.h>

int
main() {
  const
  ncl_extent	 m = 4;
  const
  ncl_extent	 n = 7;
  ncl_dmatrix	 M = ncl_dm_create(m, n);
  ncl_dsubmatrix T = ncl_dsubm_t(&M);
  ncl_dsubvector d = ncl_dsubm_diag(&M);
  ncl_dvector	 u = ncl_dv_create(n);
  ncl_dvector	 v = ncl_dv_create(n);
  ncl_dvector*	pw = ncl_dsubv_smul(
		     ncl_dsubv_sadd(
		     ncl_dsubv_ramp(ncl_dv_new(n)), 1.0), 3.0);
  ncl_dcvector	 z = ncl_dcv_create(n);

  ncl_offset	 i, j;
  for (i = 0; i < m; ++i)
    for (j = 0; j < n; ++j)
      ncl_dsubm_set(&M, i, j, (ncl_double)(10*i + j));

  fprintf(stdout, "M:\n");
  ncl_dsubm_fprintf(stdout, &M, 10, 3, 0, n);

  fprintf(stdout, "T = M^T:\n");
  ncl_dsubm_fprintf(stdout, &T, 10, 3, 0, m);

  fprintf(stdout, "d = diag(M):\n");
  ncl_dsubv_fprintf(stdout, &d, 10, 3, 0, m);

  fprintf(stdout, "u:\n");
  ncl_dsubv_fprintf(stdout, ncl_dsubv_fill(&u, 0.0), 10, 3, 0, n);

  fprintf(stdout, "v:\n");
  ncl_dsubv_fprintf(stdout, ncl_dsubv_ramp(&v), 10, 3, 0, n);

  fprintf(stdout, "u += v:\n");
  ncl_dsubv_fprintf(stdout, ncl_dsubv_vadd(&u, &v), 10, 3, 0, n);

  fprintf(stdout, "u *= v:\n");
  ncl_dsubv_fprintf(stdout, ncl_dsubv_vmul(&u, &v), 10, 3, 0, n);

  fprintf(stdout, "w:\n");
  ncl_dsubv_fprintf(stdout, pw, 10, 3, 0, n);

  fprintf(stdout, "z:\n");
  ncl_dcsubv_fprintf(stdout, ncl_dcsubv_fill(&z, ncl_dcmplx(1.0, 2.0)),
    10, 3, 0, 3);

  { ncl_dcsubvector	 v = ncl_dcsubv_odd(&z);
    fprintf(stdout, "odd z:\n");
    ncl_dcsubv_fprintf(stdout, &v, 10, 3, 0, 3);
    ncl_dcsubv_destroy(&v);
    }

  ncl_dcv_destroy(&z);
  ncl_dv_delete(pw);
  ncl_dv_destroy(&v);
  ncl_dv_destroy(&u);
  ncl_dsubv_destroy(&d);
  ncl_dsubm_destroy(&T);
  ncl_dm_destroy(&M);

  return 0;
  }
