/*
The ANSI C Numerical Class Library.
Copyright (C) 2000 E. Robert Tisdale

This file is part of The ANSI C Numerical Class Library.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/

#undef NCL_INLINE
#undef NCL_MACROS
#ifndef NCL_REVEAL
#define NCL_REVEAL
#endif  /* NCL_REVEAL */

#include<ncl_dchandle.h>

ncl_double*
ncl_dch_pointer(ncl_dchandle* ph) {
  return ph->P; }

ncl_dchandle
ncl_dch_create(ncl_dscalar* p) {
  ncl_dchandle h; h.P = p; return h; }

void
ncl_dch_destroy(ncl_dchandle* ph) {
  }

int
ncl_dch_empty(const ncl_dchandle* ph) {
  return ph->P == NULL; }

ncl_dcscalar
ncl_dch_get(const ncl_dchandle* ph,
  ncl_offset o) {
  return ((ncl_dcscalar*)(ph->P))[o]; }

void
ncl_dch_set(      ncl_dchandle* ph,
  ncl_offset o, ncl_dcscalar x) {
  ((ncl_dcscalar*)(ph->P))[o] = x; }

/* Both ncl_dch_get and ncl_dch_set assume that			*/
/* sizeof(ncl_dcscalar) == 2*sizeof(ncl_dscalar))			*/

