/*
The ANSI C Numerical Class Library.
Copyright (C) 2000 E. Robert Tisdale

This file is part of The ANSI C Numerical Class Library.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/

#undef NCL_INLINE
#undef NCL_MACROS
#ifndef NCL_REVEAL
#define NCL_REVEAL
#endif  /* NCL_REVEAL */

#include<ncl_dhandle.h>

ncl_double*
ncl_dh_pointer(ncl_dhandle* ph) {
  return ph->P; }

ncl_dhandle
ncl_dh_create(ncl_dscalar* p) {
  ncl_dhandle h; h.P = p; return h; }

void
ncl_dh_destroy(ncl_dhandle* ph) {
  }

int
ncl_dh_empty(const ncl_dhandle* ph) {
  return ph->P == NULL; }

ncl_dscalar
ncl_dh_get(const ncl_dhandle* ph,
  ncl_offset o) {
  return ((ncl_dscalar*)(ph->P))[o]; }

void
ncl_dh_set(      ncl_dhandle* ph,
  ncl_offset o, ncl_dscalar x) {
  ((ncl_dscalar*)(ph->P))[o] = x; }

