dnl This is a class prototype input file for .../<ns>/bin/genclass.
pushdef(`index', `ifelse($#, 0, ``index'', ``index($*)'')')dnl
pushdef(`shift', `ifelse($#, 0, ``shift'', ``shift($*)'')')dnl
/*
The ANSI C <namespace>.
Copyright (C) 2000 E. Robert Tisdale

This file is part of The ANSI C <namespace>.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/

#undef <NS>INLINE
#undef <NS>MACROS
#ifndef <NS>REVEAL
#define <NS>REVEAL
#endif  /* <NS>REVEAL */

#include<<ns><p><s>matrix.h>

/* Note: The pointer <ns><p>scalar* ps must be an lvalue!		*/
#define <ns><p><s>h_pointer(ph) ((ph)->P)
#define <ns><p><s>h_create(ps) (*((<ns><p><s>handle*)(&(ps))))
#define <ns><p><s>h_destroy(ph)
#define <ns><p><s>h_empty(ph) ((ph)->P == NULL)
#define <ns><p><s>h_get(ph, o) (((<ns><p><s>scalar*)((ph)->P))[o])
#define <ns><p><s>h_set(ph, o, x) (((<ns><p><s>scalar*)((ph)->P))[o] = (x))
ifelse(_system_, complex, `
/* Both <ns><p><s>h_get and <ns><p><s>h_set assume that			*/
/* sizeof(<ns><p><s>scalar) == 2*sizeof(<ns><p>scalar))			*/
')
#define <ns><p><s>subv_handle(pv) ((pv)->H);
#define <ns><p><s>subv_offset(pv) ((pv)->O);
#define <ns><p><s>subv_extent(pv) ((pv)->N);
#define <ns><p><s>subv_stride(pv) ((pv)->S);
#define <ns><p><s>subv_init(pv, h, o, n, s) \
do { \
  (pv)->H = (h); (pv)->O = (o); \
  (pv)->N = (n); (pv)->S = (s); (pv)->_ = <ns>other; \
  } while (0)
#define <ns><p><s>subv_initclone(pv, pu) <ns><p><s>subv_init(pv, \
<ns><p><s>subv_handle(pu), <ns><p><s>subv_offset(pu), \
<ns><p><s>subv_extent(pu), <ns><p><s>subv_stride(pu))
#define <ns><p><s>subv_destroy(pv) ((pv)->_ = ~<ns>other)
#define <ns><p><s>subv_empty(pv) \
(<ns><p><s>h_empty(&((pv)->H)) || 0 == <ns><p><s>subv_extent(pv))
#define <ns><p><s>subv_get(pv, j) <ns><p><s>h_get(&((pv)->H), \
<ns><p><s>subv_offset(pv) + (<ns>stride)(j)*<ns><p><s>subv_stride(pv))
#define <ns><p><s>subv_set(pv, j, x) <ns><p><s>h_set(&((pv)->H), \
<ns><p><s>subv_offset(pv) + (<ns>stride)(j)*<ns><p><s>subv_stride(pv), (x))
#define <ns><p><s>v_destroy(pv) \
do { \
  (pv)->_ = ~<ns>owner; \
  free((void*)(<ns><p><s>h_pointer(&<ns><p><s>subv_handle(pv)))); \
  } while (0)
#define <ns><p><s>v_delete(pv) \
do { <ns><p><s>v_destroy(pv); free((void*)(pv)); } while (0)

				/* define  submatrix operations		*/
<ns><p><s>handle
(<ns><p><s>subm_handle)(const <ns><p><s>submatrix* pM) { return pM->H; }

#define <ns><p><s>subm_handle(pM) ((pM)->H)

<ns>offset
(<ns><p><s>subm_offset)(const <ns><p><s>submatrix* pM) { return pM->O; }

#define <ns><p><s>subm_offset(pM) ((pM)->O)

<ns>extent
(<ns><p><s>subm_extent1)(const <ns><p><s>submatrix* pM) { return pM->N1; }

#define <ns><p><s>subm_extent1(pM) ((pM)->N1)

<ns>stride
(<ns><p><s>subm_stride1)(const <ns><p><s>submatrix* pM) { return pM->S1; }

#define <ns><p><s>subm_stride1(pM) ((pM)->S1)

<ns>extent
(<ns><p><s>subm_extent2)(const <ns><p><s>submatrix* pM) { return pM->N2; }

#define <ns><p><s>subm_extent2(pM) ((pM)->N2)

<ns>stride
(<ns><p><s>subm_stride2)(const <ns><p><s>submatrix* pM) { return pM->S2; }

#define <ns><p><s>subm_stride2(pM) ((pM)->S2)

void				/* initializer				*/
(<ns><p><s>subm_init)(<ns><p><s>submatrix* pM,
    <ns><p><s>handle h, <ns>offset o,
    <ns>extent m, <ns>stride s2,
    <ns>extent n, <ns>stride s1) {
  pM->H  = h; pM->O  = o;
  pM->N1 = n; pM->S1 = s1;
  pM->N2 = m; pM->S2 = s2; pM->_ = <ns>other; }

#define <ns><p><s>subm_init(pM, h, o, m, s2, n, s1) \
do { \
  (pM)->H  = (h); (pM)->O  = (o); \
  (pM)->N1 = (n); (pM)->S1 = (s1); \
  (pM)->N2 = (m); (pM)->S2 = (s2); (pM)->_ = <ns>other; \
  } while (0)

void				/* initializer clone			*/
(<ns><p><s>subm_initclone)(<ns><p><s>submatrix* pM,
		const <ns><p><s>submatrix* pN) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pN);
  <ns>offset	o  = <ns><p><s>subm_offset(pN);
  <ns>extent	n  = <ns><p><s>subm_extent1(pN);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pN);
  <ns>extent	m  = <ns><p><s>subm_extent2(pN);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pN);
  <ns><p><s>subm_init(pM, h, o, m, s2, n, s1); }

#define <ns><p><s>subm_initclone(pM, pN) <ns><p><s>subm_init( \
<ns><p><s>subm_handle(pN), <ns><p><s>subm_offset(pN), \
<ns><p><s>subm_extent2(pN), <ns><p><s>subm_stride2(pN), \
<ns><p><s>subm_extent1(pN), <ns><p><s>subm_stride1(pN))

<ns><p><s>submatrix		/* automatic storage constructor	*/
(<ns><p><s>subm_create)(
    <ns><p><s>handle h, <ns>offset o,
    <ns>extent m, <ns>stride s2,
    <ns>extent n, <ns>stride s1) {
  <ns><p><s>submatrix	M;
  <ns><p><s>subm_init(&M, h, o, m, s2, n, s1);
  return M; }

<ns><p><s>submatrix		/* automatic storage clone constructor	*/
(<ns><p><s>subm_createclone)(const <ns><p><s>submatrix* pN) {
  <ns><p><s>submatrix	M = *pN; M._ = <ns>other;
  return M; }

void				/* automatic storage  destructor	*/
(<ns><p><s>subm_destroy)(<ns><p><s>submatrix* pM) {
#ifdef <NS>ERRANT
  if (<ns>other != pM->_)
    <ns>message("In function <ns><p><s>subm_destroy(<ns><p><s>submatrix*):\n"
      "  argument 1 is not a valid <ns><p><s>submatrix*\n");
#endif /* <NS>ERRANT */
  pM->_ = ~<ns>other; }

#define <ns><p><s>subm_destroy(pM) (pM->_ = ~<ns>other)

<ns><p><s>submatrix*		/*      free storage constructor	*/
(<ns><p><s>subm_new)(
    <ns><p><s>handle h, <ns>offset o,
    <ns>extent m, <ns>stride s2,
    <ns>extent n, <ns>stride s1) {
  <ns><p><s>submatrix*	pM
    = (<ns><p><s>submatrix*)malloc(sizeof(<ns><p><s>submatrix));
  if (pM)
    <ns><p><s>subm_init(pM, h, o, m, s2, n, s1);
#ifdef <NS>ERRANT
  else
    <ns>message(
     "In function <ns><p><s>subm_new(<ns><p><s>handle, <ns>offset,\n"
   "  <ns>extent, <ns>stride, <ns>extent, <ns>stride):\n"
   "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
  return pM; }

<ns><p><s>submatrix*		/*      free storage clone constructor	*/
(<ns><p><s>subm_newclone)(const <ns><p><s>submatrix* pN) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pN);
  <ns>offset	o  = <ns><p><s>subm_offset(pN);
  <ns>extent	n  = <ns><p><s>subm_extent1(pN);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pN);
  <ns>extent	m  = <ns><p><s>subm_extent2(pN);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pN);
  return <ns><p><s>subm_new(h, o, m, s2, n, s1); }

void				/*      free storage  destructor	*/
(<ns><p><s>subm_delete)(<ns><p><s>submatrix* pM) {
#ifdef <NS>ERRANT
  if (<ns>other != pM->_)
    <ns>message("In function <ns><p><s>subm_delete(<ns><p><s>submatrix*):\n"
      "  argument 1 is not a valid <ns><p><s>submatrix*\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subm_destroy(pM);
  free((void*)pM); }

<ns><p><s>submatrix*		/*                 reconstructor	*/
(<ns><p><s>subm_resize)(<ns><p><s>submatrix* pM,
    <ns><p><s>handle h, <ns>offset o,
    <ns>extent m, <ns>stride s2,
    <ns>extent n, <ns>stride s1) {
#ifdef <NS>ERRANT
  if (<ns>other != pM->_)
    <ns>message(
  "In function <ns><p><s>subm_resize(<ns><p><s>submatrix*, <ns><p><s>handle,\n"
  "  <ns>offset, <ns>extent, <ns>stride, <ns>extent, <ns>stride):\n"
  "  argument 1 is not a valid <ns><p><s>submatrix*\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subm_init(pM, h, o, m, s2, n, s1);
  return pM; }

<ns><p><s>submatrix*		/*           clone reconstructor	*/
(<ns><p><s>subm_resizeclone)(<ns><p><s>submatrix* pM,
		const <ns><p><s>submatrix* pN) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pN);
  <ns>offset	o  = <ns><p><s>subm_offset(pN);
  <ns>extent	n  = <ns><p><s>subm_extent1(pN);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pN);
  <ns>extent	m  = <ns><p><s>subm_extent2(pN);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pN);
  return <ns><p><s>subm_resize(pM, h, o, m, s2, n, s1); }

int
(<ns><p><s>subm_empty)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h = <ns><p><s>subm_handle(pM);
  <ns>extent	n = <ns><p><s>subm_extent1(pM);
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  return <ns><p><s>h_empty(&h) || 0 == n || 0 == m; }

<ns><p><s>scalar
(<ns><p><s>subm_get)(const <ns><p><s>submatrix* pM,
    <ns>offset i, <ns>offset j) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  if (m <= i)
    <ns>message(
      "In function <ns><p><s>subm_get(const <ns><p><s>submatrix*,\n"
      "  <ns>offset, <ns>offset): 1st offset exceeds extent.\n");
  if (n <= j)
    <ns>message(
      "In function <ns><p><s>subm_get(const <ns><p><s>submatrix*,\n"
      "  <ns>offset, <ns>offset): 2nd offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>h_get(&h, o + (<ns>stride)j*s1 + (<ns>stride)i*s2); }

#define <ns><p><s>subm_get_(pM, i, j) \
<ns><p><s>h_get(&((pM)->H), <ns><p><s>subm_offset(pM) \
+ (<ns>stride)(j)*<ns><p><s>subm_stride1(pM) \
+ (<ns>stride)(i)*<ns><p><s>subm_stride2(pM))

void
(<ns><p><s>subm_set)(      <ns><p><s>submatrix* pM,
    <ns>offset i, <ns>offset j, <ns><p><s>scalar x) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  if (m <= i)
    <ns>message(
      "In function <ns><p><s>subm_set(<ns><p><s>submatrix*, <ns>offset,\n"
      "  <ns>offset, <ns><p><s>scalar): 1st offset exceeds extent.\n");
  if (n <= j)
    <ns>message(
      "In function <ns><p><s>subm_set(<ns><p><s>submatrix*, <ns>offset,\n"
      "  <ns>offset, <ns><p><s>scalar): 2nd offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  <ns><p><s>h_set(&h, o + (<ns>stride)j*s1 + (<ns>stride)i*s2, x); }

#define <ns><p><s>subm_set_(pM, i, j, x) \
<ns><p><s>h_set(&((pM)->H), <ns><p><s>subm_offset(pM) \
+ (<ns>stride)(j)*<ns><p><s>subm_stride1(pM) \
+ (<ns>stride)(i)*<ns><p><s>subm_stride2(pM), (x))

<ns><p><s>subvector		/*  vector view	*/
(<ns><p><s>subm_subv1)(const <ns><p><s>submatrix* pM, <ns>offset j) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  if (n <= j)
    <ns>message(
  "In function <ns><p><s>subm_subv1(const <ns><p><s>submatrix*, <ns>offset):\n"
  "  offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subv_create(h, o + (<ns>stride)j*s1, m, s2);
  }

<ns><p><s>subvector		/*  vector view	*/
(<ns><p><s>subm_subv2)(const <ns><p><s>submatrix* pM, <ns>offset i) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  if (m <= i)
    <ns>message(
    "In function <ns><p><s>subm_subv2(const <ns><p><s>submatrix*, <ns>offset):\n"
    "  offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subv_create(h, o + (<ns>stride)i*s2, n, s1);
  }

<ns><p><s>submatrix		/*  matrix view	*/
(<ns><p><s>subm_subm1)(const <ns><p><s>submatrix* pM,
    <ns>offset j, <ns>extent n, <ns>stride s) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	n_ = <ns><p><s>subm_extent1(pM);
  if (!<ns>contains(n_, j, n, s))
    <ns>message("In function <ns><p><s>subm_subm1(const <ns><p><s>submatrix*,\n"
   "  <ns>offset, <ns>extent, <ns>stride): matrix cannot contain submatrix.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subm_create(h, o + (<ns>stride)j*s1, m, s2, n, s*s1); }

<ns><p><s>submatrix		/*  matrix view	*/
(<ns><p><s>subm_subm2)(const <ns><p><s>submatrix* pM,
    <ns>offset i, <ns>extent m, <ns>stride s) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	m_ = <ns><p><s>subm_extent2(pM);
  if (!<ns>contains(m_, i, m, s))
    <ns>message("In function <ns><p><s>subm_subm2(const <ns><p><s>submatrix*,\n"
   "  <ns>offset, <ns>extent, <ns>stride): matrix cannot contain submatrix.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subm_create(h, o + (<ns>stride)i*s2, m, s*s2, n, s1); }

<ns><p><s>submatrix		/*  matrix view	*/
(<ns><p><s>subm_subm)(const <ns><p><s>submatrix* pM,
    <ns>offset i, <ns>extent m, <ns>stride s2,
    <ns>offset j, <ns>extent n, <ns>stride s1) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>stride	s1_= <ns><p><s>subm_stride1(pM);
  <ns>stride	s2_= <ns><p><s>subm_stride2(pM);
#ifdef <NS>ERRANT
  <ns>extent	n_= <ns><p><s>subm_extent1(pM);
  <ns>extent	m_= <ns><p><s>subm_extent2(pM);
  if (!(<ns>contains(n_, j, n, s1) && <ns>contains(m_, i, m, s2)))
    <ns>message("In function <ns><p><s>subm_subm(const <ns><p><s>submatrix*,\n"
"  <ns>offset, <ns>extent, <ns>stride, <ns>offset, <ns>extent, <ns>stride):\n"
"  matrix cannot contain submatrix.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subm_create(h,
    o + (<ns>stride)j*s1_ + (<ns>stride)i*s2_, m, s2*s2_, n, s1*s1_); }

<ns><p><s>submatrix		/* reverse view	*/
(<ns><p><s>subm_r1)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  o += (0 < n)? (<ns>stride)(n-1)*s1: 0;
  return <ns><p><s>subm_create(h, o, m, +s2, n, -s1); }

<ns><p><s>submatrix		/* reverse view	*/
(<ns><p><s>subm_r2)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  o += (0 < m)? (<ns>stride)(m-1)*s2: 0;
  return <ns><p><s>subm_create(h, o, m, -s2, n, +s1); }

<ns><p><s>submatrix		/* reverse view	*/
(<ns><p><s>subm_r)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  o += (0 < n)? (<ns>stride)(n-1)*s1: 0;
  o += (0 < m)? (<ns>stride)(m-1)*s2: 0;
  return <ns><p><s>subm_create(h, o, m, -s2, n, -s1); }

<ns><p><s>submatrix	/*       transpose view	*/
(<ns><p><s>subm_t)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  return <ns><p><s>subm_create(h, o, n, s1, m, s2); }

<ns><p><s>subvector	/*        diagonal view	*/
(<ns><p><s>subm_diag)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  return <ns><p><s>subv_create(h, o, ((m < n)? m: n), s1 + s2); }

<ns><p><s>submatrix		/* columns 0, 2, ...,   2j, ...		*/
(<ns><p><s>subm_even)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  return <ns><p><s>subm_create(h, o, m, s2, (n+1) >> 1, s1 << 1); }

<ns><p><s>submatrix		/* columns 1, 3, ..., 1+2j, ...		*/
(<ns><p><s>subm_odd)(const <ns><p><s>submatrix* pM) {
  <ns><p><s>handle	h  = <ns><p><s>subm_handle(pM);
  <ns>offset	o  = <ns><p><s>subm_offset(pM);
  <ns>extent	n  = <ns><p><s>subm_extent1(pM);
  <ns>stride	s1 = <ns><p><s>subm_stride1(pM);
  <ns>extent	m  = <ns><p><s>subm_extent2(pM);
  <ns>stride	s2 = <ns><p><s>subm_stride2(pM);
  return <ns><p><s>subm_create(h, o, m, s2, n >> 1, s1 << 1); }

<ns><p><s>submatrix*		/* M[i] <-> M[k]			*/
(<ns><p><s>subm_vswap)(<ns><p><s>submatrix* pM, <ns>offset i, <ns>offset k) {
#ifdef <NS>ERRANT
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  if (m <= i)
    <ns>message(
      "In function <ns><p><s>subm_swap(<ns><p><s>submatrix*,\n"
      "  <ns>offset, <ns>offset): 1st offset exceeds extent.\n");
  if (m <= k)
    <ns>message(
      "In function <ns><p><s>subm_swap(<ns><p><s>submatrix*,\n"
      "  <ns>offset, <ns>offset): 2nd offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  { <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pM, k);
    <ns><p><s>subv_vswap(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*		/* M <-> N				*/
(<ns><p><s>subm_mswap)(<ns><p><s>submatrix* pM, <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i  = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_mswap(<ns><p><s>submatrix*,\n"
      "  <ns><p><s>submatrix*): submatrices differ in 2nd extent.\n");
    mM = (mM < mN)? mM: mN;
    }
  { <ns>extent	nM = <ns><p><s>subm_extent1(pM);
    <ns>extent	nN = <ns><p><s>subm_extent1(pN);
    if (nM != nN) {
      <ns>message("In function <ns><p><s>subm_mswap(<ns><p><s>submatrix*,\n"
        "  <ns><p><s>submatrix*): submatrices differ in 1st extent.\n");
      }
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vswap(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }
ifelse(_system_, complex, `', `
<ns><p><s>submatrix*
(<ns><p><s>subm_ramp)(<ns><p><s>submatrix* pM) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_ramp(&v);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }
')dnl

<ns><p><s>submatrix*
(<ns><p><s>subm_reverse)(<ns><p><s>submatrix* pM) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_reverse(&v);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }
					/* matrix-scalar operations	*/
<ns><p><s>submatrix*			/* M  = x */
(<ns><p><s>subm_fill)(<ns><p><s>submatrix* pM, <ns><p><s>scalar x) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_fill(&v, x);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M *= x */
(<ns><p><s>subm_smul)(<ns><p><s>submatrix* pM, <ns><p><s>scalar x) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_smul(&v, x);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M *= x */
(<ns><p><s>subm_sdiv)(<ns><p><s>submatrix* pM, <ns><p><s>scalar x) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_sdiv(&v, x);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M *= x */
(<ns><p><s>subm_sadd)(<ns><p><s>submatrix* pM, <ns><p><s>scalar x) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_sadd(&v, x);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M *= x */
(<ns><p><s>subm_ssub)(<ns><p><s>submatrix* pM, <ns><p><s>scalar x) {
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subv_ssub(&v, x);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }
					/* matrix-matrix operations	*/
<ns><p><s>submatrix*			/* M  = N */
(<ns><p><s>subm_mcpy)(<ns><p><s>submatrix* pM, const <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_mcpy(<ns><p><s>submatrix*,\n"
      "  const <ns><p><s>submatrix*): submatrix differ in second extent.\n");
    mM = (mM < mN)? mM: mN;
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vcpy(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M *= N */
(<ns><p><s>subm_mmul)(<ns><p><s>submatrix* pM, const <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_mmul(<ns><p><s>submatrix*,\n"
      "  const <ns><p><s>submatrix*): submatrix differ in second extent.\n");
    mM = (mM < mN)? mM: mN;
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vmul(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M /= N */
(<ns><p><s>subm_mdiv)(<ns><p><s>submatrix* pM, const <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_mdiv(<ns><p><s>submatrix*,\n"
      "  const <ns><p><s>submatrix*): submatrix differ in second extent.\n");
    mM = (mM < mN)? mM: mN;
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vdiv(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M += N */
(<ns><p><s>subm_madd)(<ns><p><s>submatrix* pM, const <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_madd(<ns><p><s>submatrix*,\n"
      "  const <ns><p><s>submatrix*): submatrix differ in second extent.\n");
    mM = (mM < mN)? mM: mN;
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vadd(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }

<ns><p><s>submatrix*			/* M -= N */
(<ns><p><s>subm_msub)(<ns><p><s>submatrix* pM, const <ns><p><s>submatrix* pN) {
  <ns>extent	mM = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
#ifdef <NS>ERRANT
  <ns>extent	mN = <ns><p><s>subm_extent2(pN);
  if (mM != mN) {
    <ns>message("In function <ns><p><s>subm_msub(<ns><p><s>submatrix*,\n"
      "  const <ns><p><s>submatrix*): submatrix differ in second extent.\n");
    mM = (mM < mN)? mM: mN;
    }
#endif /* <NS>ERRANT */
  for (i = 0; i < mM; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    <ns><p><s>subvector	u = <ns><p><s>subm_subv2(pN, i);
    <ns><p><s>subv_vsub(&v, &u);
    <ns><p><s>subv_destroy(&u);
    <ns><p><s>subv_destroy(&v);
    }
  return pM; }
				/* define     matrix operations		*/
<ns><p><s>matrix		/* automatic storage constructor	*/
(<ns><p><s>m_create)(<ns>extent m, <ns>extent n) {
  <ns><p><s>submatrix	M;
  <ns><p>scalar*	ps
    = (<ns><p>scalar*)((0 < m*n)? malloc(m*n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
  if (!ps)
    <ns>message("In function <ns><p><s>m_create(<ns>extent, <ns>extent):\n"
      "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subm_init(&M, <ns><p><s>h_create(ps),
    (<ns>offset)0, m, n, n, (<ns>stride)1); M._ = <ns>owner;
  return M; }

<ns><p><s>matrix		/* automatic storage clone constructor	*/
(<ns><p><s>m_createclone)(const <ns><p><s>submatrix* pN) {
  <ns>extent	n = <ns><p><s>subm_extent1(pN);
  <ns>extent	m = <ns><p><s>subm_extent2(pN);
  <ns><p><s>matrix	M = <ns><p><s>m_create(m, n);
  <ns><p><s>subm_mcpy(&M, pN);
  return M; }

void				/* automatic storage  destructor	*/
(<ns><p><s>m_destroy)(<ns><p><s>matrix* pM) {
  <ns><p><s>handle	h = <ns><p><s>subm_handle(pM);
#ifdef <NS>ERRANT
  if (<ns>owner != pM->_)
    <ns>message("In function <ns><p><s>m_destroy(<ns><p><s>matrix*):\n"
      "  argument 1 is not a valid <ns><p><s>matrix*\n");
#endif /* <NS>ERRANT */
  free((void*)(<ns><p><s>h_pointer(&h)));
  }

<ns><p><s>matrix*		/*      free storage constructor	*/
(<ns><p><s>m_new)(<ns>extent m, <ns>extent n) {
  <ns><p><s>submatrix*	pM
    = (<ns><p><s>submatrix*)malloc(sizeof(<ns><p><s>submatrix));
  if (pM) {
    <ns><p>scalar*	ps
      = (<ns><p>scalar*)((0 < m*n)? malloc(m*n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
    if (!ps)
      <ns>message("In function <ns><p><s>m_new(<ns>extent, <ns>extent):\n"
      "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
    <ns><p><s>subm_init(pM, <ns><p><s>h_create(ps),
    (<ns>offset)0, m, n, n, (<ns>stride)1); pM->_ = <ns>owner;
    }
#ifdef <NS>ERRANT
  else
    <ns>message("In function <ns><p><s>m_new(<ns>extent, <ns>extent):\n"
      "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
  return pM; }

<ns><p><s>matrix*		/*      free storage clone constructor	*/
(<ns><p><s>m_newclone)(const <ns><p><s>submatrix* pN) {
  <ns>extent	n = <ns><p><s>subm_extent1(pN);
  <ns>extent	m = <ns><p><s>subm_extent2(pN);
  return <ns><p><s>subm_mcpy(<ns><p><s>m_new(m, n), pN); }

void				/*      free storage  destructor	*/
(<ns><p><s>m_delete)(<ns><p><s>matrix* pM) {
  <ns><p><s>handle	h = <ns><p><s>subm_handle(pM);
#ifdef <NS>ERRANT
  if (<ns>owner != pM->_)
    <ns>message("In function <ns><p><s>m_delete(<ns><p><s>matrix*):\n"
      "  argument 1 is not a valid <ns><p><s>matrix*\n");
#endif /* <NS>ERRANT */
  free((void*)(<ns><p><s>h_pointer(&h)));
  free((void*)pM); }

<ns><p><s>matrix*		/*                 reconstructor	*/
(<ns><p><s>m_resize)(<ns><p><s>matrix* pM, <ns>extent m, <ns>extent n) {
  <ns><p><s>handle	h = <ns><p><s>subm_handle(pM);
#ifdef <NS>ERRANT
  if (<ns>owner != pM->_) <ns>message(
 "In function <ns><p><s>m_resize(<ns><p><s>matrix*, <ns>extent, <ns>extent):\n"
 "  argument 1 is not a valid <ns><p><s>matrix*\n");
#endif /* <NS>ERRANT */
  if (!<ns><p><s>h_empty(&h)) {
    free((void*)(<ns><p><s>h_pointer(&h)));
    }
  { <ns><p>scalar*	ps
      = (<ns><p>scalar*)((0 < m*n)? malloc(m*n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
    if (!ps) <ns>message(
 "In function <ns><p><s>m_resize(<ns><p><s>matrix*, <ns>extent, <ns>extent):\n"
 "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
    <ns><p><s>subm_init(pM, <ns><p><s>h_create(ps),
      (<ns>offset)0, m, n, n, (<ns>stride)1);
    }
  return pM; }
  
<ns><p><s>matrix*		/*           clone reconstructor	*/
(<ns><p><s>m_resizeclone)(<ns><p><s>matrix* pM,
		const <ns><p><s>submatrix* pN) {
  <ns>extent	n = <ns><p><s>subm_extent1(pN);
  <ns>extent	m = <ns><p><s>subm_extent2(pN);
  return <ns><p><s>subm_mcpy(<ns><p><s>m_resize(pM, m, n), pN); }
  
int
(<ns><p><s>subm_fprintf)(FILE* stream, const <ns><p><s>submatrix* pM, 
  int width, unsigned int precision, <ns>fmtflags flags, unsigned int columns) {
  int           total = 0;
  const
  <ns>extent	m = <ns><p><s>subm_extent2(pM);
  <ns>offset	i = 0;
  for (i = 0; i < m; ++i) {
    <ns><p><s>subvector	v = <ns><p><s>subm_subv2(pM, i);
    int characters
      = <ns><p><s>subv_fprintf(stream, &v, width, precision, flags, columns);
    <ns><p><s>subv_destroy(&v);
    if (0 <= characters) { total += characters; } else { return -1; }
    }
  return total;
  }

