/*
The ANSI C Numerical Class Library.
Copyright (C) 2000 E. Robert Tisdale

This file is part of The ANSI C Numerical Class Library.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/
/* Include double complex scalar type definitions.	*/
#include<ncl_dcscalar.h>

ncl_dcomplex
(ncl_dcmplx)(ncl_double r, ncl_double i) {
  ncl_dcomplex	c;
  c.R = r; c.I = i;
  return c; }

ncl_double
(ncl_dcreal)(ncl_dcomplex c) {
  return c.R; }

#define ncl_dcreal_(c) ((c).R)

ncl_double
(ncl_dcimag)(ncl_dcomplex c) {
  return c.I; }

#define ncl_dcimag_(c) ((c).I)

int
(ncl_dcfprintf)(FILE *stream, ncl_dcomplex c,
    int width, unsigned int precision, ncl_fmtflags flags) {
  int  total = 0;
  int
  characters = fprintf(stream, "(");
  if (0 <= characters) { total += characters; } else { return -1; }
  characters =
    ncl_dfprintf(stream, ncl_dcreal_(c), width, precision, flags);
  if (0 <= characters) { total += characters; } else { return -1; }
  characters = fprintf(stream, ",");
  if (0 <= characters) { total += characters; } else { return -1; }
  characters =
    ncl_dfprintf(stream, ncl_dcimag_(c), width, precision, flags);
  if (0 <= characters) { total += characters; } else { return -1; }
  characters = fprintf(stream, ")");
  if (0 <= characters) { total += characters; } else { return -1; }
  return total;
  }

