dnl This is a class prototype input file for .../<ns>/bin/genclass.
pushdef(`index', `ifelse($#, 0, ``index'', ``index($*)'')')dnl
pushdef(`shift', `ifelse($#, 0, ``shift'', ``shift($*)'')')dnl
/*
The ANSI C <namespace>.
Copyright (C) 2000 E. Robert Tisdale

This file is part of The ANSI C <namespace>.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/

#undef <NS>INLINE
#undef <NS>MACROS
#ifndef <NS>REVEAL
#define <NS>REVEAL
#endif  /* <NS>REVEAL */

#include<<ns><p><s>vector.h>

/* Note: The pointer <ns><p>scalar* ps must be an lvalue!		*/
#define <ns><p><s>h_pointer(ph) ((ph)->P)
#define <ns><p><s>h_create(ps) (*((<ns><p><s>handle*)(&(ps))))
#define <ns><p><s>h_destroy(ph)
#define <ns><p><s>h_empty(ph) ((ph)->P == NULL)
#define <ns><p><s>h_get(ph, o) (((<ns><p><s>scalar*)((ph)->P))[o])
#define <ns><p><s>h_set(ph, o, x) (((<ns><p><s>scalar*)((ph)->P))[o] = (x))
ifelse(_system_, complex, `
/* Both <ns><p><s>h_get and <ns><p><s>h_set assume that			*/
/* sizeof(<ns><p><s>scalar) == 2*sizeof(<ns><p>scalar))			*/
')
				/* define  subvector operations		*/
<ns><p><s>handle
(<ns><p><s>subv_handle)(const <ns><p><s>subvector* pv) { return pv->H; }

#define <ns><p><s>subv_handle(pv) ((pv)->H)

<ns>offset
(<ns><p><s>subv_offset)(const <ns><p><s>subvector* pv) { return pv->O; }

#define <ns><p><s>subv_offset(pv) ((pv)->O)

<ns>extent
(<ns><p><s>subv_extent)(const <ns><p><s>subvector* pv) { return pv->N; }

#define <ns><p><s>subv_extent(pv) ((pv)->N)

<ns>stride
(<ns><p><s>subv_stride)(const <ns><p><s>subvector* pv) { return pv->S; }

#define <ns><p><s>subv_stride(pv) ((pv)->S)

void				/* initializer				*/
(<ns><p><s>subv_init)(<ns><p><s>subvector* pv,
    <ns><p><s>handle h, <ns>offset o, <ns>extent n, <ns>stride s) {
  pv->H = h; pv->O = o; pv->N = n; pv->S = s; pv->_ = <ns>other; }

#define <ns><p><s>subv_init(pv, h, o, n, s) \
do { \
  (pv)->H = (h); \
  (pv)->O = (o); (pv)->N = (n); (pv)->S = (s); (pv)->_ = <ns>other; \
  } while (0)

void				/* initializer clone			*/
(<ns><p><s>subv_initclone)(<ns><p><s>subvector* pv,
		const <ns><p><s>subvector* pu) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pu);
  <ns>offset	o = <ns><p><s>subv_offset(pu);
  <ns>extent	n = <ns><p><s>subv_extent(pu);
  <ns>stride	s = <ns><p><s>subv_stride(pu);
  <ns><p><s>subv_init(pv, h, o, n, s); }

#define <ns><p><s>subv_initclone(pv, pu) <ns><p><s>subv_init(pv, \
<ns><p><s>subv_handle(pu), <ns><p><s>subv_offset(pu), \
<ns><p><s>subv_extent(pu), <ns><p><s>subv_stride(pu))

<ns><p><s>subvector		/* automatic storage constructor	*/
(<ns><p><s>subv_create)(
    <ns><p><s>handle h, <ns>offset o, <ns>extent n, <ns>stride s) {
  <ns><p><s>subvector	v;
  <ns><p><s>subv_init(&v, h, o, n, s);
  return v; }

<ns><p><s>subvector		/* automatic storage clone constructor	*/
(<ns><p><s>subv_createclone)(const <ns><p><s>subvector* pu) {
  <ns><p><s>subvector	v = *pu; v._ = <ns>other;
  return v; }

void				/* automatic storage  destructor	*/
(<ns><p><s>subv_destroy)(<ns><p><s>subvector* pv) {
#ifdef <NS>ERRANT
  if (<ns>other != pv->_)
    <ns>message("In function <ns><p><s>subv_destroy(<ns><p><s>subvector*):\n"
      "  argument 1 is not a valid <ns><p><s>subvector*\n");
#endif /* <NS>ERRANT */
  pv->_ = ~<ns>other; }

#define <ns><p><s>subv_destroy(pv) (pv->_ = ~<ns>other)

<ns><p><s>subvector*		/*      free storage constructor	*/
(<ns><p><s>subv_new)(
    <ns><p><s>handle h, <ns>offset o, <ns>extent n, <ns>stride s) {
  <ns><p><s>subvector*	pv
    = (<ns><p><s>subvector*)malloc(sizeof(<ns><p><s>subvector));
  if (pv)
    <ns><p><s>subv_init(pv, h, o, n, s);
#ifdef <NS>ERRANT
  else
    <ns>message("In function <ns><p><s>subv_new(<ns><p><s>handle,\n"
      "  <ns>offset, <ns>extent, <ns>stride): memory allocation failed.\n");
#endif /* <NS>ERRANT */
  return pv; }

<ns><p><s>subvector*		/*      free storage clone constructor	*/
(<ns><p><s>subv_newclone)(const <ns><p><s>subvector* pu) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pu);
  <ns>offset	o = <ns><p><s>subv_offset(pu);
  <ns>extent	n = <ns><p><s>subv_extent(pu);
  <ns>stride	s = <ns><p><s>subv_stride(pu);
  return <ns><p><s>subv_new(h, o, n, s); }

void				/*      free storage  destructor	*/
(<ns><p><s>subv_delete)(<ns><p><s>subvector* pv) {
#ifdef <NS>ERRANT
  if (<ns>other != pv->_)
    <ns>message("In function <ns><p><s>subv_delete(<ns><p><s>subvector*):\n"
      "  argument 1 is not a valid <ns><p><s>subvector*\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subv_destroy(pv);
  free((void*)pv); }

<ns><p><s>subvector*		/*                 reconstructor	*/
(<ns><p><s>subv_resize)(<ns><p><s>subvector* pv,
    <ns><p><s>handle h, <ns>offset o, <ns>extent n, <ns>stride s) {
#ifdef <NS>ERRANT
  if (<ns>other != pv->_)
    <ns>message("In function <ns><p><s>subv_resize(<ns><p><s>subvector*,\n"
      "<ns><p><s>handle, <ns>offset, <ns>extent, <ns>stride):\n"
      "  argument 1 is not a valid <ns><p><s>subvector*\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subv_init(pv, h, o, n, s);
  return pv; }

<ns><p><s>subvector*		/*           clone reconstructor	*/
(<ns><p><s>subv_resizeclone)(<ns><p><s>subvector* pv,
		const <ns><p><s>subvector* pu) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pu);
  <ns>offset	o = <ns><p><s>subv_offset(pu);
  <ns>extent	n = <ns><p><s>subv_extent(pu);
  <ns>stride	s = <ns><p><s>subv_stride(pu);
  return <ns><p><s>subv_resize(pv, h, o, n, s); }

int
(<ns><p><s>subv_empty)(const <ns><p><s>subvector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  return <ns><p><s>h_empty(&h) || 0 == n; }

<ns><p><s>scalar
(<ns><p><s>subv_get)(const <ns><p><s>subvector* pv,
    <ns>offset j) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
#ifdef <NS>ERRANT
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  if (n <= j)
    <ns>message(
      "In function <ns><p><s>subv_get(const <ns><p><s>subvector*,\n"
        "  <ns>offset): offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>h_get(&h, o + (<ns>stride)j*s); }

#define <ns><p><s>subv_get_(pv, j) <ns><p><s>h_get(&((pv)->H), \
<ns><p><s>subv_offset(pv) + (<ns>stride)(j)*<ns><p><s>subv_stride(pv))

void
(<ns><p><s>subv_set)(      <ns><p><s>subvector* pv,
    <ns>offset j, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
#ifdef <NS>ERRANT
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  if (n <= j)
    <ns>message(
      "In function <ns><p><s>subv_set(const <ns><p><s>subvector*,\n"
        "  <ns>offset, <ns><p><s>scalar): offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  <ns><p><s>h_set(&h, o + (<ns>stride)j*s, x); }

#define <ns><p><s>subv_set_(pv, j, x) <ns><p><s>h_set(&((pv)->H), \
<ns><p><s>subv_offset(pv) + (<ns>stride)(j)*<ns><p><s>subv_stride(pv), (x))

<ns><p><s>subvector		/*  vector view	*/
(<ns><p><s>subv_subv)(const <ns><p><s>subvector* pv,
    <ns>offset j, <ns>extent n, <ns>stride s) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>stride	s_= <ns><p><s>subv_stride(pv);
#ifdef <NS>ERRANT
  <ns>extent	n_= <ns><p><s>subv_extent(pv);
  if (!<ns>contains(n_, j, n, s))
   <ns>message("In function <ns><p><s>subv_subv(const <ns><p><s>subvector*,\n"
   "  <ns>offset, <ns>extent, <ns>stride): vector cannot contain subvector.\n");
#endif /* <NS>ERRANT */
  return <ns><p><s>subv_create(h, o + (<ns>stride)j*s, n, s*s_); }
  
<ns><p><s>subvector		/* reverse view	*/
(<ns><p><s>subv_r)(const <ns><p><s>subvector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  o += (0 < n)? (<ns>stride)(n-1)*s: 0;
  return <ns><p><s>subv_create(h, o, n, -s); }

<ns><p><s>subvector		/* elements 0, 2, ...,   2j, ...	*/
(<ns><p><s>subv_even)(const <ns><p><s>subvector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  return <ns><p><s>subv_create(h, o, (n+1) >> 1, s << 1); }

<ns><p><s>subvector		/* elements 1, 3, ..., 1+2j, ...	*/
(<ns><p><s>subv_odd)(const <ns><p><s>subvector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  return <ns><p><s>subv_create(h, o, n >> 1, s << 1); }

<ns><p><s>subvector*		/* v[j] <-> v[k]			*/
(<ns><p><s>subv_sswap)(<ns><p><s>subvector* pv, <ns>offset j, <ns>offset k) {
  <ns><p><s>scalar	t = <ns><p><s>subv_get_(pv, j);
#ifdef <NS>ERRANT
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  if (n <= j)
    <ns>message(
      "In function <ns><p><s>subv_sswap(const <ns><p><s>subvector*,\n"
      "  <ns>offset, <ns>offset): first offset exceeds extent.\n");
  if (n <= k)
    <ns>message(
      "In function <ns><p><s>subv_sswap(const <ns><p><s>subvector*,\n"
      "  <ns>offset, <ns>offset): second offset exceeds extent.\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subv_set_(pv, j, <ns><p><s>subv_get_(pv, k));
  <ns><p><s>subv_set_(pv, k, t);
  return pv; }

<ns><p><s>subvector*		/* v <-> u				*/
(<ns><p><s>subv_vswap)(<ns><p><s>subvector* pv, <ns><p><s>subvector* pu) {
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>offset	j  = 0;
#ifdef <NS>ERRANT
  <ns>extent	nu = <ns><p><s>subv_extent(pu);
  if (nv != nu) {
    <ns>message("In function <ns><p><s>subv_vswap(<ns><p><s>subvector*,\n"
      "  <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nu)? nv: nu;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>scalar	t = <ns><p><s>subv_get(pv, j);
    <ns><p><s>subv_set(pv, j, <ns><p><s>subv_get(pu, j));
    <ns><p><s>subv_set(pu, j, t);
    }
  return pv; }
ifelse(_system_, complex, `', `
<ns><p><s>subvector*
(<ns><p><s>subv_ramp)(<ns><p><s>subvector* pv) {
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j)
    <ns><p><s>subv_set_(pv, j, (<ns><p><s>scalar)j);
  return pv; }
')dnl
					/* vector-scalar operations	*/
<ns><p><s>subvector*
(<ns><p><s>subv_reverse)(<ns><p><s>subvector* pv) {
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>extent	m = n >> 1;
  <ns>offset	j = 0;
  for (j = 0; j < m; ++j)
    <ns><p><s>subv_sswap(pv, j, n-j);
  return pv; }
					/* vector-scalar operations	*/
<ns><p><s>subvector*			/* v  = x */
(<ns><p><s>subv_fill)(<ns><p><s>subvector* pv, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j) {
    <ns><p><s>h_set(&h, o, x);
    o += s; }
  return pv; }

<ns><p><s>subvector*			/* v *= x */
(<ns><p><s>subv_smul)(<ns><p><s>subvector* pv, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>MUL(t, <ns><p><s>h_get(&h, o), x);
    <ns><p><s>h_set(&h, o, t);
    o += s; }
  return pv; }

<ns><p><s>subvector*			/* v /= x */
(<ns><p><s>subv_sdiv)(<ns><p><s>subvector* pv, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>DIV(t, <ns><p><s>h_get(&h, o), x);
    <ns><p><s>h_set(&h, o, t);
    o += s; }
  return pv; }

<ns><p><s>subvector*			/* v += x */
(<ns><p><s>subv_sadd)(<ns><p><s>subvector* pv, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>ADD(t, <ns><p><s>h_get(&h, o), x);
    <ns><p><s>h_set(&h, o, t);
    o += s; }
  return pv; }

<ns><p><s>subvector*			/* v -= x */
(<ns><p><s>subv_ssub)(<ns><p><s>subvector* pv, <ns><p><s>scalar x) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
  <ns>offset	o = <ns><p><s>subv_offset(pv);
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>stride	s = <ns><p><s>subv_stride(pv);
  <ns>offset	j = 0;
  for (j = 0; j < n; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>SUB(t, <ns><p><s>h_get(&h, o), x);
    <ns><p><s>h_set(&h, o, t);
    o += s; }
  return pv; }

					/* vector-vector operations	*/
<ns><p><s>subvector*			/* v  = w */
(<ns><p><s>subv_vcpy)(<ns><p><s>subvector* pv, const <ns><p><s>subvector* pw) {
  <ns><p><s>handle	hv = <ns><p><s>subv_handle(pv);
  <ns>offset	ov = <ns><p><s>subv_offset(pv);
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>stride	sv = <ns><p><s>subv_stride(pv);
  <ns><p><s>handle	hw = <ns><p><s>subv_handle(pw);
  <ns>offset	ow = <ns><p><s>subv_offset(pw);
  <ns>stride	sw = <ns><p><s>subv_stride(pw);
  <ns>offset	j = 0;
#ifdef <NS>ERRANT
  <ns>extent	nw = <ns><p><s>subv_extent(pw);
  if (nv != nw) {
    <ns>message("In function <ns><p><s>subv_vcpy(<ns><p><s>subvector*,\n"
      "  const <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nw)? nv: nw;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>h_set(&hv, ov, <ns><p><s>h_get(&hw, ow));
    ov += sv;
    ow += sw; }
  return pv; }

<ns><p><s>subvector*			/* v *= w */
(<ns><p><s>subv_vmul)(<ns><p><s>subvector* pv, const <ns><p><s>subvector* pw) {
  <ns><p><s>handle	hv = <ns><p><s>subv_handle(pv);
  <ns>offset	ov = <ns><p><s>subv_offset(pv);
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>stride	sv = <ns><p><s>subv_stride(pv);
  <ns><p><s>handle	hw = <ns><p><s>subv_handle(pw);
  <ns>offset	ow = <ns><p><s>subv_offset(pw);
  <ns>stride	sw = <ns><p><s>subv_stride(pw);
  <ns>offset	j = 0;
#ifdef <NS>ERRANT
  <ns>extent	nw = <ns><p><s>subv_extent(pw);
  if (nv != nw) {
    <ns>message("In function <ns><p><s>subv_vmul(<ns><p><s>subvector*,\n"
      "  const <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nw)? nv: nw;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>MUL(t,
      <ns><p><s>h_get(&hv, ov),
      <ns><p><s>h_get(&hw, ow));
    <ns><p><s>h_set(&hv, ov, t);
    ov += sv;
    ow += sw; }
  return pv; }

<ns><p><s>subvector*			/* v /= w */
(<ns><p><s>subv_vdiv)(<ns><p><s>subvector* pv, const <ns><p><s>subvector* pw) {
  <ns><p><s>handle	hv = <ns><p><s>subv_handle(pv);
  <ns>offset	ov = <ns><p><s>subv_offset(pv);
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>stride	sv = <ns><p><s>subv_stride(pv);
  <ns><p><s>handle	hw = <ns><p><s>subv_handle(pw);
  <ns>offset	ow = <ns><p><s>subv_offset(pw);
  <ns>stride	sw = <ns><p><s>subv_stride(pw);
  <ns>offset	j = 0;
#ifdef <NS>ERRANT
  <ns>extent	nw = <ns><p><s>subv_extent(pw);
  if (nv != nw) {
    <ns>message("In function <ns><p><s>subv_vdiv(<ns><p><s>subvector*,\n"
      "  const <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nw)? nv: nw;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>DIV(t,
      <ns><p><s>h_get(&hv, ov),
      <ns><p><s>h_get(&hw, ow));
    <ns><p><s>h_set(&hv, ov, t);
    ov += sv;
    ow += sw; }
  return pv; }

<ns><p><s>subvector*			/* v += w */
(<ns><p><s>subv_vadd)(<ns><p><s>subvector* pv, const <ns><p><s>subvector* pw) {
  <ns><p><s>handle	hv = <ns><p><s>subv_handle(pv);
  <ns>offset	ov = <ns><p><s>subv_offset(pv);
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>stride	sv = <ns><p><s>subv_stride(pv);
  <ns><p><s>handle	hw = <ns><p><s>subv_handle(pw);
  <ns>offset	ow = <ns><p><s>subv_offset(pw);
  <ns>stride	sw = <ns><p><s>subv_stride(pw);
  <ns>offset	j = 0;
#ifdef <NS>ERRANT
  <ns>extent	nw = <ns><p><s>subv_extent(pw);
  if (nv != nw) {
    <ns>message("In function <ns><p><s>subv_vadd(<ns><p><s>subvector*,\n"
      "  const <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nw)? nv: nw;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>ADD(t,
      <ns><p><s>h_get(&hv, ov),
      <ns><p><s>h_get(&hw, ow));
    <ns><p><s>h_set(&hv, ov, t);
    ov += sv;
    ow += sw; }
  return pv; }

<ns><p><s>subvector*			/* v -= w */
(<ns><p><s>subv_vsub)(<ns><p><s>subvector* pv, const <ns><p><s>subvector* pw) {
  <ns><p><s>handle	hv = <ns><p><s>subv_handle(pv);
  <ns>offset	ov = <ns><p><s>subv_offset(pv);
  <ns>extent	nv = <ns><p><s>subv_extent(pv);
  <ns>stride	sv = <ns><p><s>subv_stride(pv);
  <ns><p><s>handle	hw = <ns><p><s>subv_handle(pw);
  <ns>offset	ow = <ns><p><s>subv_offset(pw);
  <ns>stride	sw = <ns><p><s>subv_stride(pw);
  <ns>offset	j = 0;
#ifdef <NS>ERRANT
  <ns>extent	nw = <ns><p><s>subv_extent(pw);
  if (nv != nw) {
    <ns>message("In function <ns><p><s>subv_vsub(<ns><p><s>subvector*,\n"
      "  const <ns><p><s>subvector*): subvectors differ in extent.\n");
    nv = (nv < nw)? nv: nw;
    }
#endif /* <NS>ERRANT */
  for (j = 0; j < nv; ++j) {
    <ns><p><s>scalar	t;
    <NS><P><S>SUB(t,
      <ns><p><s>h_get(&hv, ov),
      <ns><p><s>h_get(&hw, ow));
    <ns><p><s>h_set(&hv, ov, t);
    ov += sv;
    ow += sw; }
  return pv; }
				/* define     vector operations		*/
<ns><p><s>vector		/* automatic storage constructor	*/
(<ns><p><s>v_create)(<ns>extent n) {
  <ns><p><s>subvector	v;
  <ns><p>scalar*	ps
    = (<ns><p>scalar*)((0 < n)? malloc(n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
  if (!ps)
    <ns>message(
"In function <ns><p><s>v_create(<ns>extent): memory allocation failed.\n");
#endif /* <NS>ERRANT */
  <ns><p><s>subv_init(&v, <ns><p><s>h_create(ps),
    (<ns>offset)0, n, (<ns>stride)1); v._ = <ns>owner;
  return v; }

<ns><p><s>vector		/* automatic storage clone constructor	*/
(<ns><p><s>v_createclone)(const <ns><p><s>subvector* pu) {
  <ns><p><s>vector	v = <ns><p><s>v_create(<ns><p><s>subv_extent(pu));
  <ns><p><s>subv_vcpy(&v, pu);
  return v; }

void				/* automatic storage  destructor	*/
(<ns><p><s>v_destroy)(<ns><p><s>vector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
#ifdef <NS>ERRANT
  if (<ns>owner != pv->_)
    <ns>message("In function <ns><p><s>v_destroy(<ns><p><s>vector*):\n"
      "  argument 1 is not a valid <ns><p><s>vector*\n");
#endif /* <NS>ERRANT */
  free((void*)(<ns><p><s>h_pointer(&h)));
  }

<ns><p><s>vector*		/*      free storage constructor	*/
(<ns><p><s>v_new)(<ns>extent n) {
  <ns><p><s>subvector*	pv
    = (<ns><p><s>subvector*)malloc(sizeof(<ns><p><s>subvector));
  if (pv) {
    <ns><p>scalar*	ps
       = (<ns><p>scalar*)((0 < n)? malloc(n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
    if (!ps)
      <ns>message(
        "In function <ns><p><s>v_new(<ns>extent): memory allocation failed.\n");
#endif /* <NS>ERRANT */
    <ns><p><s>subv_init(pv, <ns><p><s>h_create(ps),
    (<ns>offset)0, n, (<ns>stride)1); pv->_ = <ns>owner;
    }
#ifdef <NS>ERRANT
  else
    <ns>message(
      "In function <ns><p><s>v_new(<ns>extent): memory allocation failed.\n");
#endif /* <NS>ERRANT */
  return pv; }

<ns><p><s>vector*		/*      free storage clone constructor	*/
(<ns><p><s>v_newclone)(const <ns><p><s>subvector* pu) {
  return <ns><p><s>subv_vcpy(<ns><p><s>v_new(<ns><p><s>subv_extent(pu)), pu); }

void				/*      free storage  destructor	*/
(<ns><p><s>v_delete)(<ns><p><s>vector* pv) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
#ifdef <NS>ERRANT
  if (<ns>owner != pv->_)
    <ns>message("In function <ns><p><s>v_delete(<ns><p><s>vector*):\n"
      "  argument 1 is not a valid <ns><p><s>vector*\n");
#endif /* <NS>ERRANT */
  free((void*)(<ns><p><s>h_pointer(&h)));
  free((void*)pv); }

<ns><p><s>vector*		/*                 reconstructor	*/
(<ns><p><s>v_resize)(<ns><p><s>vector* pv, <ns>extent n) {
  <ns><p><s>handle	h = <ns><p><s>subv_handle(pv);
#ifdef <NS>ERRANT
  if (<ns>owner != pv->_)
    <ns>message(
      "In function <ns><p><s>v_resize(<ns><p><s>vector*, <ns>extent):\n"
      "  argument 1 is not a valid <ns><p><s>vector*\n");
#endif /* <NS>ERRANT */
  if (!<ns><p><s>h_empty(&h)) {
    free((void*)(<ns><p><s>h_pointer(&h)));
    }
  { <ns><p>scalar*	ps
      = (<ns><p>scalar*)((0 < n)? malloc(n*sizeof(<ns><p><s>scalar)): NULL);
#ifdef <NS>ERRANT
    if (!ps)
      <ns>message(
        "In function <ns><p><s>v_resize(<ns><p><s>vector*, <ns>extent):\n"
        "  memory allocation failed.\n");
#endif /* <NS>ERRANT */
    <ns><p><s>subv_init(pv, <ns><p><s>h_create(ps),
      (<ns>offset)0, n, (<ns>stride)1);
    }
  return pv; }
  
<ns><p><s>vector*		/*           clone reconstructor	*/
(<ns><p><s>v_resizeclone)(
    <ns><p><s>vector* pv, const <ns><p><s>subvector* pu) {
  return <ns><p><s>subv_vcpy(
    <ns><p><s>v_resize(pv, <ns><p><s>subv_extent(pu)), pu); }
  
int
(<ns><p><s>subv_fprintf)(FILE* stream, const <ns><p><s>subvector* pv, 
  int width, unsigned int precision, <ns>fmtflags flags, unsigned int columns) {
  int           characters;
  int           total = 0;
  const
  <ns>extent	n = <ns><p><s>subv_extent(pv);
  <ns>offset	j = 0;
ifelse(system, complex,
`  columns = (0 < columns)? columns: 2;
',
`  columns = (0 < columns)? columns: 4;
')dnl
  for (j = 0; j < n; ++j) {
    if (0 < j) {
      characters
         = (0 == j%columns)? fprintf(stream, "\n"): fprintf(stream, " ");
      if (0 <= characters) { total += characters; } else { return -1; }
      }
    characters = <ns><p><s>fprintf(
      stream, <ns><p><s>subv_get_(pv, j), width, precision, flags);
    if (0 <= characters) { total += characters; } else { return -1; }
    }
  characters = fprintf(stream, "\n");
  if (0 <= characters) { total += characters; } else { return -1; }
  return total;
  }

