c     matrix.f
c 
c The Fortran 77 Numerical Class library
c Copyright (C) 2000 E. Robert Tisdale
c 
c This file is part of The Fortran 77 Numerical Class library.
c This library is free software which you can redistribute and/or modify
c under the terms of the GNU Library General Public License
c as published by the Free Software Foundation;
c either version 2, or (at your option) any later version.
c 
c This library is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty
c of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
c See the GNU General Public License for more details.
c 
c You should have received a copy of the GNU Library General Public License
c along with this library.  If not, write to the Free Software Foundation,
c Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c 
c Written by E. Robert Tisdale
c 
      integer function subm_handle(pm)
        include "memory.h"
        integer pm
        subm_handle = i_get(pm + ishft(0, iShift))
        end

      integer function subm_offset(pm)
        integer pm
        include "memory.h"
        subm_offset = i_get(pm + ishft(1, iShift))
        end

      integer function subm_extent1(pm)
        integer pm
        include "memory.h"
        subm_extent1 = i_get(pm + ishft(2, iShift))
        end

      integer function subm_stride1(pm)
        integer pm
        include "memory.h"
        subm_stride1 = i_get(pm + ishft(3, iShift))
        end

      integer function subm_extent2(pm)
        integer pm
        include "memory.h"
        subm_extent2 = i_get(pm + ishft(4, iShift))
        end

      integer function subm_stride2(pm)
        integer pm
        include "memory.h"
        subm_stride2 = i_get(pm + ishft(5, iShift))
        end

      subroutine subm_init(pm, h, o, n1, s1, n2, s2)
        integer	pm, h, o, n1, s1, n2, s2
        include "handle.h"
        call i_set(pm + ishft(0, iShift), h)
        call i_set(pm + ishft(1, iShift), o)
        call i_set(pm + ishft(2, iShift), n1)
        call i_set(pm + ishft(3, iShift), s1)
        call i_set(pm + ishft(4, iShift), n2)
        call i_set(pm + ishft(5, iShift), s2)
        call i_set(pm + ishft(6, iShift), other)
        end

      subroutine subm_initclone(pm, pn)
        integer	pm, pn
        include "handle.h"
        call i_set(pm + ishft(0, iShift), i_get(pn + ishft(0, iShift)))
        call i_set(pm + ishft(1, iShift), i_get(pn + ishft(1, iShift)))
        call i_set(pm + ishft(2, iShift), i_get(pn + ishft(2, iShift)))
        call i_set(pm + ishft(3, iShift), i_get(pn + ishft(3, iShift)))
        call i_set(pm + ishft(4, iShift), i_get(pn + ishft(4, iShift)))
        call i_set(pm + ishft(5, iShift), i_get(pn + ishft(5, iShift)))
        call i_set(pm + ishft(6, iShift), other)
        end

      subroutine subm_destroy(pm)
        integer	pm
        include "handle.h"
        call i_set(pm + ishft(6, iShift), not(other))
        end

      integer function isubm_get(pm, i, j)
        integer pm, i, j
        include "handle.h"
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        isubm_get = ih_get(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm))
        end

      real*4 function ssubm_get(pm, i, j)
        integer pm, i, j
        include "handle.h"
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        ssubm_get = sh_get(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm))
        end

      real*8 function dsubm_get(pm, i, j)
        integer pm, i, j
        include "handle.h"
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        dsubm_get = dh_get(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm))
        end

      complex*8  function scsubm_get(pm, i, j)
        integer pm, i, j
        include "handle.h"
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        scsubm_get = sch_get(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm))
        end

      complex*16 function dcsubm_get(pm, i, j)
        integer pm, i, j
        include "handle.h"
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        dcsubm_get = dch_get(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm))
        end

      subroutine isubm_set(pm, i, j, x)
        integer pm, i, j
        include "handle.h"
        integer*4 x
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        call ih_set(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm), x)
        end

      subroutine ssubm_set(pm, i, j, x)
        include "handle.h"
        integer pm, i, j
        integer*4 x
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        call sh_set(subm_handle(pm), subm_offset(pm)
     1    + (i-1)*subm_stride1(pm) + (j-1)*subm_stride2(pm), x)
        end

      subroutine dsubm_set(m, i, j, x)
        include "handle.h"
        integer m(subm_size), i, j
        integer*4 x
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        call dh_set(subm_handle(m), subm_offset(m)
     1    + (i-1)*subm_stride1(m) + (j-1)*subm_stride2(m), x)
        end

      subroutine scsubm_set(m, i, j, x)
        include "handle.h"
        integer m(subm_size), i, j
        integer*4 x
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        call sch_set(subm_handle(m), subm_offset(m)
     1    + (i-1)*subm_stride1(m) + (j-1)*subm_stride2(m), x)
        end

      subroutine dcsubm_set(m, i, j, x)
        include "handle.h"
        integer m(subm_size), i, j
        integer*4 x
        integer subm_handle, subm_offset, subm_stride1, subm_stride2
        call dch_set(subm_handle(m), subm_offset(m)
     1    + (i-1)*subm_stride1(m) + (j-1)*subm_stride2(m), x)
        end

