/*
c      memory_.c
c 
c The Fortran 77 Numerical Class library
c Copyright (C) 2000 E. Robert Tisdale
c 
c This file is part of The Fortran 77 Numerical Class library.
c This library is free software which you can redistribute and/or modify
c under the terms of the GNU Library General Public License
c as published by the Free Software Foundation;
c either version 2, or (at your option) any later version.
c 
c This library is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty
c of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
c See the GNU General Public License for more details.
c 
c You should have received a copy of the GNU Library General Public License
c along with this library.  If not, write to the Free Software Foundation,
c Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c 
c Written by E. Robert Tisdale
*/

#include<stdlib.h>
#include<string.h>

#ifdef f2c_i2
/* for -i2 */
typedef short flag;
typedef short ftnlen;
typedef short ftnint;
#else
typedef long int flag;
typedef long int ftnlen;
typedef long int ftnint;
#endif

typedef char	character;
typedef int	pointer;
typedef int	integer;
typedef float	single;

typedef struct { single r, i; } singleComplex;
typedef struct { double r, i; } doubleComplex;

#define	 cShift 0
#define	 iShift 2
#define	 sShift 2
#define	 dShift 3
#define	scShift 3
#define	dcShift 4

pointer
malloc_(size_t* pn) { return (pointer)malloc(*pn); }

int
free_(pointer* p) { free((void*)(*p)); return 0; }

pointer
clocation_(character* c, ftnlen n) { return (pointer)c; }

pointer
ilocation_(integer* i) { return (pointer)i; }

pointer
slocation_(single* s) { return (pointer)s; }

pointer
dlocation_(double* d) { return (pointer)d; }

pointer
sclocation_(doubleComplex* c) { return (pointer)c; }

pointer
dclocation_(doubleComplex* z) { return (pointer)z; }

pointer
callocate_(size_t* pn) { return (pointer)malloc(*pn << cShift); }

pointer
iallocate_(size_t* pn) { return (pointer)malloc(*pn << iShift); }

pointer
sallocate_(size_t* pn) { return (pointer)malloc(*pn << sShift); }

pointer
dallocate_(size_t* pn) { return (pointer)malloc(*pn << dShift); }

pointer
scallocate_(size_t* pn) { return (pointer)malloc(*pn << scShift); }

pointer
dcallocate_(size_t* pn) { return (pointer)malloc(*pn << dcShift); }

void
c_get__(character* c, ftnlen n, character** p) { *c = **p; }

integer
i_get__(integer** p) { return **p; }

single
s_get__(single** p) { return **p; }

double
d_get__(double** p) { return **p; }

singleComplex
sc_get__(singleComplex** p) { return **p; }

doubleComplex
dc_get__(doubleComplex** p) { return **p; }

int
i_set__(integer** p, integer* px) { **p = *px; }

int
s_set__(single** p, single* px) { **p = *px; }

int
d_set__(double** p, double* px) { **p = *px; }

int
sc_set__(singleComplex** p, singleComplex* px) { **p = *px; }

int
dc_set__(doubleComplex** p, doubleComplex* px) { **p = *px; }

