c     vector.f
c 
c The Fortran 77 Numerical Class library
c Copyright (C) 2000 E. Robert Tisdale
c 
c This file is part of The Fortran 77 Numerical Class library.
c This library is free software which you can redistribute and/or modify
c under the terms of the GNU Library General Public License
c as published by the Free Software Foundation;
c either version 2, or (at your option) any later version.
c 
c This library is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty
c of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
c See the GNU General Public License for more details.
c 
c You should have received a copy of the GNU Library General Public License
c along with this library.  If not, write to the Free Software Foundation,
c Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c 
c Written by E. Robert Tisdale
c 
      integer function subv_handle(pv)
        integer pv
        include "memory.h"
        subv_handle = i_get(pv + ishft(0, iShift))
        end

      integer function subv_offset(pv)
        integer pv
        include "memory.h"
        subv_offset = i_get(pv + ishft(1, iShift))
        end

      integer function subv_extent(pv)
        integer pv
        include "memory.h"
        subv_extent = i_get(pv + ishft(2, iShift))
        end

      integer function subv_stride(pv)
        integer pv
        include "memory.h"
        subv_stride = i_get(pv + ishft(3, iShift))
        end

      subroutine subv_init(pv, h, o, n, s)
        integer	pv, h, o, n, s
        include "handle.h"
        call i_set(pv + ishft(0, iShift), h)
        call i_set(pv + ishft(1, iShift), o)
        call i_set(pv + ishft(2, iShift), n)
        call i_set(pv + ishft(3, iShift), s)
        call i_set(pv + ishft(4, iShift), other)
        end

      subroutine subv_initclone(pv, pu)
        integer	pv, pu
        include "handle.h"
        call i_set(pv + ishft(0, iShift), i_get(pu + ishft(0, iShift)))
        call i_set(pv + ishft(1, iShift), i_get(pu + ishft(1, iShift)))
        call i_set(pv + ishft(2, iShift), i_get(pu + ishft(2, iShift)))
        call i_set(pv + ishft(3, iShift), i_get(pu + ishft(3, iShift)))
        call i_set(pv + ishft(4, iShift), other)
        end

      subroutine subv_destroy(pv)
        integer	pv
        include "handle.h"
        call i_set(pv + ishft(4, iShift), not(other))
        end

      integer function isubv_get(pv, i)
        integer pv, i
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        isubv_get = ih_get(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv))
        end

      real*4 function ssubv_get(pv, i)
        integer pv, i
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        ssubv_get = sh_get(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv))
        end

      real*8 function dsubv_get(pv, i)
        integer pv, i
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        dsubv_get = dh_get(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv))
        end

      complex*8  function scsubv_get(pv, i)
        integer pv, i
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        scsubv_get = sch_get(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv))
        end

      complex*16 function dcsubv_get(pv, i)
        integer pv, i
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        dcsubv_get = dch_get(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv))
        end


      subroutine isubv_set(pv, i, x)
        integer pv, i
        integer*4 x
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        call ih_set(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv), x)
        end

      subroutine ssubv_set(pv, i, x)
        integer pv, i
        real*4 x
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        call sh_set(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv), x)
        end

      subroutine dsubv_set(pv, i, x)
        integer pv, i
        real*8 x
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        call dh_set(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv), x)
        end

      subroutine scsubv_set(pv, i, x)
        integer pv, i
        complex*8  x
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        call sch_set(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv), x)
        end

      subroutine dcsubv_set(pv, i, x)
        integer pv, i
        complex*16 x
        include "handle.h"
        integer subv_handle, subv_offset, subv_stride
        call dch_set(subv_handle(pv),
     1    subv_offset(pv) + (i-1)*subv_stride(pv), x)
        end

