dnl This is a class prototype input file for .../svmt/bin/genclass.
pushdef(`index', `ifelse($#, 0, ``index'', ``index($*)'')')dnl
pushdef(`shift', `ifelse($#, 0, ``shift'', ``shift($*)'')')dnl
/*
The C++ Scalar, Vector, Matrix and Tensor classes.
Copyright (C) 1998 E. Robert Tisdale

This file is part of The C++ Scalar, Vector, Matrix and Tensor classes.
This library is free software which you can redistribute and/or modify
under the terms of the GNU Library General Public License
as published by the Free Software Foundation;
either version 2, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License
along with this library.  If not, write to the Free Software Foundation,
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Written by E. Robert Tisdale
*/

#include<<Type><System>Square.h>

define(_point_,
ifelse(_type_, long double, floating,
ifelse(_type_,      double, floating,
ifelse(_type_,       float, floating, fixed))))dnl
define(TYPE, ifelse(_system_, complex, `<Type><System>', `<type>'))dnl
define(ZERO, ifelse(_system_, complex,
  `<Type><System>((<type>)0, (<type>)0)', `(<type>)0'))dnl
// Functions
<Type><System>SubSquare&
<Type><System>SubSquare::transpose(void) {
  <Type><System>SubSquare&	M = *this;
  <Type><System>SubSquare	T = M.t();
  Extent			m = extent2();
  for (Offset i = 1; i < m; i++) {
    <Type><System>SubVector	u = M[i].sub(0, i, 1);
    <Type><System>SubVector	v = T[i].sub(0, i, 1);
    u.swap(v);
    }
  return *this;
  }
const
<Type><System>Square
<Type><System>SubMatrix::dot(void) const {
  const
  <Type><System>SubMatrix&	M = *this;
  <Type><System>Square		S(extent2());
  for (Offset i = 0; i < extent2(); i++) {
    for (Offset j = 0; j < i; j++)
      S[j][i] = S[i][j] = M[i].dot(M[j]);
    S[i][i] = M[i].dot(M[i]);
    }
  return S;
  }

// Cholesky decomposition with pivoting.
const
offsetVector
  <Type><System>SubSquare::lld(void) {
  Extent			m = extent2();
  offsetVector			p(m);	// permutation vector
  if (0 < m) {				// Ignore superdiagonal elements.
    <Type><System>SubSquare&	L = *this;	// lower triangular view
    <Type><System>SubSquare	U = L.t();	// upper triangular view
    <Type><System>SubVector	d = L.diag();	//	   diagonal view
    p.ramp();
  
    for (Offset i = 0; i < m-1; i++) {	// all except the last column
ifelse(_system_, complex,
`      Offset	k = i + norm(d.sub(i, m-i, 1)).max();	// pivot row and column
',
`      Offset	k = i + d.sub(i, m-i, 1).max();	// pivot row and column
')dnl
      if (i < k) {
	// Swap row i for row k and column i for column k
 	// without disturbing any superdiagonal elements.
	if (0 < i) {
	  <Type><System>SubVector	l = L[k].sub(0, i, 1);
	  L[i].sub(0, i, 1).swap(l);
	  }
	if (k+1 < m) {
	  <Type><System>SubVector	u = U[k].sub(k+1, m-k-1, 1);
	  U[i].sub(k+1, m-k-1, 1).swap(u);
          }
        if (i+1 < k) {
	  <Type><System>SubVector	u = U[i].sub(i+1, k-i-1, 1);
	  L[k].sub(i+1, k-i-1, 1).swap(u);
	  }
	d.swap(i, k);			// Swap L[i][i] and L[k][k].
	p.swap(i, k);			// Update the permutation vector.
	}
ifelse(_system_, complex,
`      if (0 < norm(L[i][i])) {		// still nonsingular
',
`      if (0 < L[i][i]) {		// still positive definite
')dnl
	L[i][i] = sqrt(L[i][i]);
	<Type><System>SubVector	u = U[i].sub(i+1, m-i-1, 1);
	if (0 < i)
	  u -= L[i].sub(0, i, 1).dot(L.sub(i+1, m-i-1, 1, 0, i, 1));
	u /= L[i][i];
	d.sub(i+1, m-i-1, 1) -= u*u;
	}
      else
	break;
      }
ifelse(_system_, complex,
`    if (0 < norm(L[m-1][m-1])) {	// still nonsingular
',
`    if (0 < L[m-1][m-1]) {		// still positive definite
')dnl
      L[m-1][m-1] = sqrt(L[m-1][m-1]);	// last row and column
      }
    }
  return p;
  }

// Operators
popdef(`index')dnl
popdef(`shift')dnl

